function [s] = DoActionMatrix(action,s, tau)

%s is a state vector
%action is action matirx with rows being seprate actions

numActions = size(action,1);

phi         = s(7);
theta      = s(9);
phi_dot     = s(8);
theta_dot     = s(10);
rot1 = [sin(theta) -1 cos(theta)] .* [sin(phi) cos(phi) sin(phi)];
rot2 = [-1 * cos(theta) 0 sin(theta)] .* [cos(phi) 0 cos(phi)];

s = repmat(s, numActions, 1);

% Parameters for simulation
p = [s(:,1) s(:,3) s(:,5)];
v = [s(:,2) s(:,4) s(:,6)];

acc = action;

% velicity and position update
p = p + v*tau + 0.5*tau^2*acc;
v = v + tau * acc;

l_w = 0.62;
g = 9.81;

accg = acc - repmat([0 0 g], numActions, 1);
ddphi_w = accg * rot1' /l_w;
ddtheta_w = accg * rot2' /l_w;

phi = phi + phi_dot*tau + 0.5 * tau^2*ddphi_w;
theta = theta + theta_dot*tau + 0.5 * tau^2*ddtheta_w;

phi_dot = phi_dot + tau*ddphi_w;
theta_dot = theta_dot + tau*ddtheta_w;

s = [ p(:,1) v(:,1) p(:,2) v(:,2) p(:,3) v(:,3) phi phi_dot theta theta_dot];
