function [ r,f ] = GetReward( s, a )
% r: the returned reward.
% f: true if the car reached the goal, otherwise f is false

% Parameters for simulation
x          = s(1);
y          = s(3);
z          = s(5);

x_dot      = s(2);
y_dot      = s(4);
z_dot      = s(6);

p1         = s(7);
p2         = s(9);
p1_dot     = s(8);
p2_dot     = s(10);

f = false;
distanceToGoal = x^2 + y^2 + z^2;

% penalize distance from the goal
r1 = -7500* distanceToGoal;
r2=0;
speed = (x_dot^2 + y_dot^2 + z_dot^2);
%r2= 7 * speed;

r5=0;
swing_speed = p1_dot^2 + p2_dot^2;
%r5 = -1 * (p1_dot^2 + p2_dot^2); 
% no swining at destination

swingSize = p1^2 + p2^2;
r3 = -100 * swingSize;
if  (distanceToGoal < 0.05^2 && swingSize < (1*pi/180)^2 && speed < 0.05^2 && swing_speed < (5*pi/180)^2) %sqrt(distanceToGoal) <= 0.05
    f = true;
    r3 = r3+ 10000;
    r2=0;
    %           r2 = -1* (x_dot^2 + y_dot^2 + z_dot^2)
end

% z must be positive
r4 = 0;
if (z<0)
    r4 = -10000;
end
if (x>0.1)
%    r4 = r4-10000;
end
if (y>0.1)
%    r4 = r4-10000;
end
r6 = 0; %-1* a*a';
r = r1 + r2 + r3 + r4 + r5 + r6;

end



