function [trajectory r fi] = executePolicy(theta, getFeatures, rewardFunction,...
    state, numSteps, tau, actions, gamma, displayValue,noiseExecFactor)

tic

% construct noise for the state execution
noiseExec = 1 + (2*rand(numSteps,10)-1) * noiseExecFactor;

% initalize the trajectory
trajectory = zeros(numSteps+1,size(state,2) + size(actions,2));
trajectory(1,1:size(state,2)) = state;
value = zeros(numSteps);
reward = zeros(numSteps);
fi=numSteps;
currentAction = [0 0 0];

%% start building the trajectory
for i=1:numSteps
i    
    % we only use the completion parameter to be able stop 
    % when the goal is reached, reward is not used other than graphing
    [r completed] = rewardFunction(state, currentAction);
    
    % find action that transitions to a state with the highest velue
    tstates = DoActionMatrix(actions, state, tau);
    q = (getFeatures(tstates) * theta) ;    
    [v inx] = max(q);
    currentAction = actions(inx,:);
    
    % perform the action with the best value
    state = noiseExec(i,:) .* DoActionMatrix(currentAction, state, tau);
    trajectory(i+1,1:10) = state;
    trajectory(i+1,11:13) = currentAction;
    
    value(i) = v;
    reward(i) = r;
    
    if completed
        disp(['Goal accomlished at ' num2str(tau*i) ' s']);
        fi = i+1;
        value = value(1:i);
        reward = reward(1:i);
        break;
    end
end
r = toc;

if displayValue ~= 0
    figure('Name','Value');
    plot(value);
    
    figure('Name','Reward');
    plot(reward);
end
end
