function theta = runFittedIteration(rewardFunction, ...
    samplingLowerBound, samplingUpperBound , getFeatures,...
    tau, actions, gamma, numIterations)

%% Fitted Iteration

f = 4;   % feature vector dimensionality
m = 400; %number of samples

theta = zeros(f,1);

diff = zeros(numIterations,1);
for j=1:numIterations
    j
    %% for each sampling episode
    m = j+10; %increase number of smaples
    y = zeros(1,m)';
    
    % sample the learning domain
    sampledStates = getRandomStates(m,samplingLowerBound, samplingUpperBound);
    parfor i=1:m %for each sample
        
        %observe the reward
        r = rewardFunction(sampledStates(i,:), tau*j);
        %sample the transitions
        states = DoActionMatrix(actions, sampledStates(i,:), tau);
        
        q = repmat(r,size(actions,1),1) + gamma *  (getFeatures(states) * theta) ;

        %% new estimate of the samples state
        y(i) = max(q);
    end
    
    psi = getFeatures(sampledStates); %old estimates of the sampled states
    theta = (psi' * psi)\ psi' * y; % linear regression that minimizes 
                                    % sq. diff netween old and new estimates
end


end