function runMe

T           = 15;         % duration of an episode in s
maxSteps    = T * 50;     % maximum number of steps per for trajectory genetation
numIterations = 1000;     % number of iterations per episode in learning
tau         = T/maxSteps; % time segement for each step
gamma       = 0.9;        % discount factor
noiseFactor = 0.00;       % change this for stochastic simulator
displayValueFunction = 1; % display the accomulated and experienced reward

h = [0 0];                % handle for plots
actions = BuildActionList;

%% initialize task
rewardFunction     =@GetReward; %pointer to the reward function
getFeatures     = @getPsi; % pointer to the feature vector calculation

% learning domain bounds
samplingUpperBound   =  [1, 3, 1, 3 , 1, 3 , 10 * pi/ 180, 10 , 10 * pi/180, 10 ]; %[1, 3, 1, 3 , 1, 3 , 10 * pi/ 180, 5 * pi/ 180 , 10 * pi/180, 5 * pi/ 180 ];
samplingLoweBound    = -1 * samplingUpperBound;


%% Learn the feature vector parametrization: theta
tic
theta       = runFittedIteration(rewardFunction, ...
    samplingLoweBound, samplingUpperBound , getFeatures,...
    tau, actions, gamma, numIterations);

toc

%% trajectory generation
initState = [-2, 0, -2, 0, 1, 0, 0 ,0 ,0, 0]; %initial state (-2, -2, 1)

[trajectory  r fi] = executePolicy(theta, getFeatures, rewardFunction, ...
    initState, maxSteps, tau, actions, gamma, displayValueFunction, noiseFactor);

showTrajectory(trajectory,tau,fi,h);

end